package com.dd.admin.business.api;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.dd.admin.business.note.domain.NoteDto;
import com.dd.admin.business.note.domain.NoteVo;
import com.dd.admin.common.aop.operationLog.aop.OperLog;
import com.dd.admin.common.aop.operationLog.aop.OperType;
import com.dd.admin.common.exception.ApiException;
import com.dd.admin.common.model.result.ResultBean;
import com.dd.admin.common.utils.RedisUtil;
import com.dd.admin.common.utils.StringUtil;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class AuthApi {

    @Autowired
    RedisUtil redisUtil;

    @ApiOperation(value = "获取验证码")
    @ApiOperationSupport(order = 1)
    @GetMapping("/api/auth/getCode")
    @OperLog(operModule = "获取验证码",operType = OperType.QUERY,operDesc = "获取验证码")
    public ResultBean<String> page(String phoneNumber) {
        String code = sendSmsCode(phoneNumber);
        return ResultBean.success(code);
    }



    public String sendSmsCode(String phoneNumber) {
        String redisKey = "SMS_CODE" + phoneNumber;
        String smsCode = String.valueOf(redisUtil.get(redisKey));
        if(StringUtil.isNotEmpty(smsCode)){
            throw new ApiException("验证码已发送，请稍后再试" + smsCode);
        }
        String code = StringUtil.createCode(4);
        //设置有效时间
//        String json = JavaSmsApi.tplSingleSend(phoneNumber,CODE_TPL_ID, BeanUtil.beanToMap(new SmsCode(code)));

//        Map dataMap = (Map) JSON.parse(json);
//        if(dataMap.get("msg").equals("发送成功")){
        if(true){
            System.out.println(code);
            redisUtil.set(redisKey,code,120);
            return code;
        }else{
            throw new ApiException("发送失败");
//            throw new ApiException("发送失败,"+dataMap.get("msg"));
        }
    }

}
